﻿public class PrintInvisibleObjects
{
    [DeclareAction("PrintInvisibleObjects")]

    public void PrintInvisibleObjectsVoid()
    {

        ////////////////////////////////////////////////////////////////////////
        // Allgemeine Funktionen
        ////////////////////////////////////////////////////////////////////////

        // Projektdatei, Projektpfad, Projektname
        string sSelectedProjectData = string.Empty;     // kompletter Pfad + Projektdateinamen + Erweiterung
        string sSelectedProjectName = string.Empty;     // Projektname

        // Projektdatei komplett
        CommandLineInterpreter oCLI = new CommandLineInterpreter();
        Eplan.EplApi.ApplicationFramework.ActionCallingContext ctx = new Eplan.EplApi.ApplicationFramework.ActionCallingContext();
        ctx.AddParameter("TYPE", "PROJECT");

        bool bRet = oCLI.Execute("selectionset", ctx); // Action: Projektpfad
        if (bRet == true)
        {
            ctx.GetParameter("PROJECT", ref sSelectedProjectData);
        }

        // Projektname
        sSelectedProjectName = System.IO.Path.GetFileNameWithoutExtension(sSelectedProjectData);


        ////////////////////////////////////////////////////////////////////////
        // Yes/No Abfrage
        ////////////////////////////////////////////////////////////////////////

        // Setting
        Eplan.EplApi.Base.Settings oSettings = new Eplan.EplApi.Base.Settings(); 

        // Dialog
        DialogResult oDialogResult = new DialogResult();
        oDialogResult = MessageBox.Show("Sollen unsichtbare Elemente gedruckt werden?", "Drucken [" + sSelectedProjectName + "]", MessageBoxButtons.YesNo);
        
      if (oDialogResult == DialogResult.Yes )
        {
            // Ja
            oSettings.SetBoolSetting("USER.GedViewer.Print.PrintInvisibleObjects", true, 0); 
        }

        else
        {
            // Nein
            oSettings.SetBoolSetting("USER.GedViewer.Print.PrintInvisibleObjects", false, 0); 
        }


        // Verbindungen aktualisieren
        oCLI.Execute("EsGenerateConnections");

        // Drucken-Dialog öffnen
        oCLI.Execute("PrnPrintDialogShow");
        


        return;
    }

}

